﻿using System;
using System.ServiceModel;
using Artech.WasHostingDemo.Contracts;

namespace Artech.WasHostingDemo.Client
{
    class Program
    {
        static void Main(string[] args)
        {
            using (ChannelFactory<ICalculator> channelFactory = new ChannelFactory<ICalculator>("calculatorservice"))
            {
                ICalculator calculator = channelFactory.CreateChannel();
                using (calculator as IDisposable)
                {
                    try
                    {
                        Console.WriteLine("x + y = {2} when x = {0} and y = {1}", 1, 2, calculator.Add(1, 2));
                    }
                    catch (CommunicationException)
                    {
                        (calculator as ICommunicationObject).Abort();
                        throw;
                    }
                    catch (TimeoutException)
                    {
                        (calculator as ICommunicationObject).Abort();
                        throw;
                    }
                }
            }
        }
    }
}
